OpenTTD Source: HouseResolverObject Struct Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Data Fields
HouseResolverObject Struct Reference

Resolver object to be used for houses (feature 07 spritegroups). More...

`#include <newgrf_house.h>`

Inheritance diagram for HouseResolverObject:

## Public Member Functions
| HouseResolverObject (HouseID house_id, TileIndex tile, Town *town, CallbackID callback=CBID_NO_CALLBACK, uint32_t param1=0, uint32_t param2=0, bool not_yet_constructed=false, uint8_t initial_random_bits=0, CargoTypes watched_cargo_triggers=0)
| Construct a resolver for a house. More...
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0) override
| Get a resolver for the scope. More...
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for. More...
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved. More...
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor. More...
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup. More...
uint16_t | ResolveCallback ()
| Resolve callback. More...
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const
| Get the real sprites of the grf. More...
uint32_t | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with. More...
void | ResetState ()
| Resets the dynamic state of the resolver object. More...

## Data Fields
HouseScopeResolver | house_scope
TownScopeResolver | town_scope
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32_t | callback_param1
| First parameter (var 10) of the callback.
uint32_t | callback_param2
| Second parameter (var 18) of the callback.
uint32_t | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32_t | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32_t | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Resolver object to be used for houses (feature 07 spritegroups).

Definition at line 51 of file newgrf_house.h.

## Constructor & Destructor Documentation

## ◆ HouseResolverObject()

HouseResolverObject::HouseResolverObject | ( | HouseID | house_id,
|  | TileIndex | tile,
|  | Town * | town,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | param1 = `0`,
|  | uint32_t | param2 = `0`,
|  | bool | not_yet_constructed = `false`,
|  | uint8_t | initial_random_bits = `0`,
|  | CargoTypes | watched_cargo_triggers = `0`
| ) |  |

Construct a resolver for a house.

Parameters

  house_id | House to query.
  tile | Tile containing the house.
  town | Town containing the house.
  callback | Callback ID.
  param1 | First parameter (var 10) of the callback.
  param2 | Second parameter (var 18) of the callback.
  not_yet_constructed | House is still under construction.
  initial_random_bits | Random bits during construction checks.
  watched_cargo_triggers | Cargo types that triggered the watched cargo callback.

Definition at line 55 of file newgrf_house.cpp.

References HouseSpec::grf_prop, ResolverObject::root_spritegroup, and GRFFilePropsBase< Tcnt >::spritegroup.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t HouseResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 70 of file newgrf_house.cpp.

References HouseSpec::grf_prop, HouseScopeResolver::house_id, and GRFFilePropsBase< Tcnt >::local_id.

## ◆ GetFeature()

GrfSpecFeature HouseResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 65 of file newgrf_house.cpp.

## ◆ GetScope()

ScopeResolver* HouseResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 59 of file newgrf_house.h.

References ResolverObject::GetScope(), VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

Referenced by NIHHouse::Resolve().

The documentation for this struct was generated from the following files:

- src/newgrf_house.h
- src/newgrf_house.cpp